---
layout: post
title: "My Personal Learning Habits and Techniques"
date: 2018-12-27 19:21:23 +0800
author: foo-dogsquared
categories: learning
tags: [self-learning, techniques]
---

> Learning is the process of acquiring new or modifying existing knowledge, behaviors, skills, values, or preferences. 
>
> – Wikipedia

Let's talk something different (or maybe not, as I always tend to insert something about it) today: LEARNING, as in the art of learning!

Like what I've said inside of the parenthesis, I've always tried to talk something about learning as a way to enforce myself into immersion. Being in a state of 'in the zone', as they say, and I get to appreciate the skill of learning and my progress every once in a while.

Learning is also a skill. Being a skill means that we can upgrade it but conversely, it can also mean that our learning skill can be stagnant or worsen over time if left unpracticed. Fortunately, like all skills, there are ways and practices on how to learn more efficiently and retain more important information on our mind. 

Bear in mind that these techniques will not guarantee to help you learn more efficiently as we all have a different perspective on learning, thus, the same techniques applied have different effects among each other. We have to know what works for us and if we don't, then we can just try new stuff and patiently wait for the result while still consistently doing the course.

Anyways, here is the breakdown of the different practices that I practice (and will do) that can help on learning more efficiently:

## Learning modes
This is based on the study of one of Coursera's famous course, [Learning How to Learn](https://www.coursera.org/learn/learning-how-to-learn/), instructed by Barbara Oakley and Terrence Sejnowski. 

This is the first thing that you need to know about so take heed and attention to this one.

Our brain has different modes that affect how we learn. From the instructors of the aforementioned Coursera course, they identified two distinct modes: focused mode and diffuse mode. Learning involves going back and forth between these two modes. They are not tools used exclusively for different purposes. They complement each other in a way to get the information you want to stay on your memory.

Learning is not particularly a one-way process. All of us have gone through to learn the same concept in a similar but different manner (I guess you can say consistent). A lot of us learn when there are a crystal-clear indication and a sense of focus on the things that we do. Others may have understood the concept while they are doing entirely something else unrelated to what they're doing. Like I've said, there are basically different ways on how we learn.

### Focus mode
Let's say that we are an archaeologist (you know, like Indiana Jones) trying to explore an ancient pyramid. There, we discovered a very dark room. We flash our flashlight in what appears to be hieroglyphics that is written on the wall.

If we want to extract what is the exact story in the hieroglyphics, we might want the light to shine only on a limited area to prevent distracting ourselves from reading other parts and cutting our reading and translating session. Not only do we have a light that limits to a certain area but also it gives off a brighter light compared when we move the flashlight far away from the wall.

![The area of the light when it is near from the surface]({{ 'assets/pictures/self-learning-series/personal-workflow/flashlight-focus-mode-analogy.png' | relative_url }})
<p class="caption">*What usually when we have the flashlight near the surface*</p>

That's our focus mode from a learning perspective. Obviously, the light represents our brain and the writings in the wall represent the idea or the concept that we try to understand or solve. **We only shine on certain information to be used in our situation that mostly needs concentration.** Examples include solving a math problem, giving directions to a known place, programming a simple app, and reading a textbook. When we have entered in this mode, not only that the scope of our focus narrows but also we have a higher precision to retrieve more relevant information.

Often than not, this is the time where we feel that we are truly learning but it isn't exactly the case. This is the mode where we often use the information, ideas, and details of a concept we've already known to solve a particular type of problem that we already encountered. Simply put, we just have the slight familiarity needed to solve the problem or review and re-understand a concept. 

Of course, being an activity, it could also drain our mental energy very quickly to the point of mental fatigue. This begs the question of how do we learn a concept that is entirely new and unfamiliar to our brain.

### Diffused mode
That's where the other mode comes into the scene: the diffused mode. But first, let's go back to the hypothetical situation that involves reading the hieroglyphics in a pitch-black room.

On the other hand, when we want to skim through the hieroglyphics to know what it is about, we may want to move the flashlight farther away from the wall to produce a larger but softer light, enabling us to see the writings altogether. From there, we just dart our eyes around the different hieroglyphics, getting clues everywhere we could salvage, and trying to connect to make up a summary.

![The area of the light when it is far away from the surface]({{ 'assets/pictures/self-learning-series/personal-workflow/flashlight-diffused-mode-analogy.png' | relative_url }})
<p class="caption">*What usually when we move the flashlight farther away*</p>

This is our diffused mode in that perspective. **Diffused mode is the mode wherein we feel relaxed and move away from focusing**. It may also make us feel like we're not learning at all but it is generally not the case. 

Similar to how the light's area is directly proportional to the distance from the wall but inversely proportional to the sharpness of the light, being in diffused mode lets us see other unrelated things however we experience a blur on the inner details of a concept or an idea. This is quite the opposite of focus mode wherein we are capable of retrieving and minding relevant detailed information within a concept.

It may seem counterintuitive but utilizing this mode efficiently is the key to understanding new and unknown concepts. Most of the time, it serves as the mode to build connections between two unrelated neural connections. Without it, we can't see the big picture of the thing and may prevent us from connecting the dots from a general perspective.

Another thing to mind in this mode that despite that we feel relaxed and not working at all, our brain is still working on the information that we gather and used during our focused mode. It has just been working in the background rather than the foreground. We simply don't mind it ourselves. When we don't think about the problem ourselves, our brain is subconsciously working on that problem, even in our sleep! 

### Utilizing both modes
Our brain can go into either mode but not at the same time, similar to how we don't see both sides of a coin at the same time. Furthermore, it is impossible for our brain to not think or function at all. Even if we experience it, it'll just work on the background, silently trying to tie up the information that we gather and doing its duty as a central government of our body.

Feeling stuck in learning new concepts is apparently normal. It often serves as a sign of stepping away from being focused. It doesn't hurt to not think about it for a moment. So when we are experiencing that situation, just go on something different then come back later. Usually with our brain refreshed with the ability to see a thing or an idea from a new perspective.

We don't learn solely on being focused. We need other inputs for that, too. Being on diffused mode helps us get other perspectives that we might not have gotten when we're in focus mode. Thus, it can help us solve problems or understand unknown concepts in new ways that we don't expect.

You might've gotten this 'Eureka!' or 'Aha!' moment when trying to solve a problem or understand something unfamiliar. You might have completely understood how to solve that math problem that you minded so much during the exam just right after it. Or you might have understood a concept just after waking up after all of that reading in a textbook. That's the result your brain going in the two modes.

If you're quite curious how to efficiently utilize these two modes, here are some of the techniques I've learned and used to get you some perspective that you can use yourself:

## Feynman technique
What this about is that you can learn a lot by teaching somebody who is not well-versed on the subject matter. Named after Richard Feynman, a famous scientist and a great teacher, bestowed with the title of the "Great Explainer" due to his excellence in teaching complex concepts into simple digestible bits. This is the very core principle I take every time I write a post on this blog, at least in the technical articles like my *Simplified!* series.

The Feynman technique can also serve as a tool for making how much have you progressed through your learning session or how deep is your understanding in a particular concept or a subject matter. By explaining it in a non-technical person (or an imaginary friend or person), you are being challenged by trying to explain the concept in your own words. Sure, you can just search up a CONCEPT 101 explanation or an ELI5 (Explain Like I'm 5) but not all people appeal to those kinds of abstraction to be able to understand the topic. And hey, there's a lot of ways on how you can utilize this technique from picking the persona of this assumed non-technical person you're talking whether it's a friend or your colleague to your speaking persona whether it's a casual one or a professional-sounding one.

The best of all things is that this technique can be applied anywhere you can think of when it comes to studying (the usual one): notebooks, blogs, social media posts, anywhere you're comfortable with. Even better, why not make a system of your own embedded with the principle of this technique?

The way I applied it is similar to what [this article](http://www.openculture.com/2017/04/richard-feynmans-notebook-technique-will-help-you-learn-any-subject.html) describes how is the technique done. I have a notebook for the things that I don't know and my blog for the things that I'm somewhat sure that I can explain it. I first take my notes on the notebook and as I got the concepts more and more clearly, that's where I start to write some stuff on my usual text editor for my blog.

Aside from my blog, I've also created [a remote repo that contains notes on things that I don't know](https://github.com/foo-dogsquared/a-remote-repo-full-of-notes-of-things-i-do-not-know-about) serving as an additional notebook. In fact, I've been trying to make a system out of it which will be explained later.

## Growth mindset
The concept of mindset is in a kind of recent academic spotlight now ever since research towards learning and education is growing widespread. In this paper, we'll talk about the kinds of mindset according to Carol Dweck. According to her, the types of mindset are categorized on their views on where their ability came from.

Mainly there's two, the *fixed mindset* and the *growth mindset*. Basically, the former mindset is the belief that skills are made and pre-determined from birth.

Having this particular mindset doesn't magically makes you the next Elon Musk, Steve Jobs, Bill Gates, or any of the owners of a megacorporation, superpower, or a [zaibatsu](https://en.wikipedia.org/wiki/Zaibatsu). It, however, helps you redefine how you interact with things throughout your life. Specifically, your mindset or your set of beliefs.

Having a growth mindset is said to be more grounded in reality, having the ability to take risks and persists through the skin of things because people with growth mindset know that if we want our future to be realized, we have to get through those obstacles.

Research shows that intelligence is not fixed and can change its status over time by a lot of factors. Nowadays, this is termed as [neuroplasticity](https://www.brainhq.com/brain-resources/brain-plasticity/what-is-brain-plasticity). This opens up a whole new world on how to improve ourselves, mentally speaking.

Now what's so great about growth mindset is that the moment we saw an article, watched a video, or listened to a podcast episode about this growth mindset, its beneficial effect can already be felt. This is because our brain now knows that intelligence is not fixed or static throughout the lifetime. Rather, it can change and our mindset potentially changes.

While I'm not fully going to discuss what is growth mindset, I recommend to at least go read a research article or a video about that topic. It'll get you further into internalizing this set of belief onto yourself and hopefully lead a better life. 

## Spaced repetition
This is something that I learned from one of the most famous Coursera course, [Learning How to Learn](https://www.coursera.org/learn/learning-how-to-learn/). This is a course that I definitely recommend. It is suited to everyone no matter what profession or age and it offers a lot of information backed up by two credible figures, Barbara Oakley and Terrence Sejnowski each having their worldwide recognized contributions on learning and its relation to neuroscience.

### What is it
Spaced repetition is a learning technique that is utilized by spacing out your study sessions. It exploits the memory phenomenon of [spacing effect](https://en.wikipedia.org/wiki/Spacing_effect) whereby the tendency of learning is greater when spread out over time compared to massing it all in a single time.

Anyways, one of the underlying concepts of spaced repetition is on the physical processes that are happening inside of our brain. In order to understand and learn a concept, the neurons have to make connections. These neural connections get stronger each time we repeat and retrieve the information from our mind catalog. However, these neural connections have to take some time and any interruptions such as filling up too fast. This is especially important if we are learning right from scratch. 

Think of learning as building a foundation made up of bricks. In creating a brick foundation (or a wall), we don't build it in one swoop. In order to make up a sturdy cemented foundation, we have to set aside some time for the mortar to hold the bricks then apply the next set of bricks that'll be applied on top of it.

For a further analogy, we can think of the bricks as the information that we try to hold in our mind and the cement is the neurons trying to make a solid neural connection. When we have all of the bricks laid out on the foundation, it is a very big factor in understanding more noble concepts. If the foundation is wonkily made or we rush in making the foundation, it can make the house in danger. Otherwise, it can be the key to building a safe house.

### The antithesis of spaced repetition
Before we talk more on the topic of spaced repetition, we will shortly talk about a very common occurrence among students. If the last sentence in the previous paragraph somewhat rings you a bell, you might have thought of *cramming*. This is the antithesis of spaced repetition. **Cramming is basically trying to force our brain to take all of the information at one time.** 

We have seen the brick wall/foundation analogy before and I'm pretty sure you can tell by intuition as to what the equivalent of that. If we are going to make an equivalent on the analogy, it is basically building a brick wall sloppily. We are trying to build the wall as fast as we can and it'll result in a wall failing to do its duty as a wall. In a bigger context, if we would try to build a foundation rushingly, it would result in a very detrimental situation in the long run despite the shorter time that it took.

### How to apply it
The principle of spaced repetition is quite simple. The practice is made up of mainly four parts: repetition, time distance, quality, and consistency.

- *repetition* is the number of sessions that you'll practice
- *time distance* is the gap between study sessions
- *quality* is the amount of effort to go about your limits
- *consistency* is the average amount of quality that you put each practice session

What makes this practice so powerful is another principle that is inherent in the phenomenon it is based on which is the *desirable difficulty*, a learning factor that encourages more effort and difficulty while being accomplishable. It allows us to maximize learning in an efficient time frame.

Of course, there are ways on how to apply this principle in practice. It'll be just based upon your creativity but if you're looking for ways right now, here are some of them:

#### Leitner system
Basically, you have a set number of the box. Each of those boxes represents the increasing time intervals. If I have three boxes, for example, I would have set the three boxes with the following time intervals:

| Box number | Time interval
| --- |
| 1 | Every day
| 2 | Every week
| 3 | Every two weeks

Now that we have the set of boxes ready, we have to make the solutions through flash cards. 

![Leitner system example]({{ 'assets/pictures/self-learning-series/personal-workflow/leitner-system-example.png' | relative_url }})
<p class="caption">*An example of using the Leitner system*</p>

All of the flash cards start with the first box. Basically, you try to recall information that is written in the flash card. If you succeed, you promote the card into the next box. **Otherwise, it would be there to stay or if the card is already promoted, it would go back to the first box, no matter where it is**. This is to force you to learn more about it. 

Now, all you have to do is make use of your calendar so you can track which of the items in the box should be studied.

Well, the materials that this method requires does not have to be followed to the T. You can make an alternative as long as you represented the boxes and its content. Thomas Frank from [College Info Geek](https://collegeinfogeek.com/) made a [portable analog version of the system](https://collegeinfogeek.com/spaced-repetition-memory-technique#the-analog-spaced-repetition-system).

However, if you are lazy to make the physical version of the thing much like I am, you can also download computer programs that utilize this system in one way or another.

The most popular is [Anki](https://apps.ankiweb.net/), having the ability to rate the difficulty of a flash card that also serves as a digital box of the Leitner system. The ones that you rated difficult will be in the next deck, the ones that you rated easy will appear in the next days, and so on, you get the idea. One of the biggest positive points of Anki is that it is supported by a massive community compared to other apps. You can also import decks created by other users but I always recommend to make your own.

Well, actually most of the point of using this app correlates very much with another technique in here which I'm going to elaborate it in that particular technique.

## Recalling
Perhaps one of the simplest and usual way of making the concept to be cemented in our mind. All of us are doing this in some way. Common occurrences include after skimming after a paragraph of a story, iterating through the examples in a lesson, and reading through a technical article. 

Simply the act of recalling is quite enough for most of us to sail through a lesson in an academic environment. However, in the technical setting, it is almost like an art. It is an important skill for a professional to flexibly recall information especially that most information is used in parallel with other information.

Also, through recalling, we are building up our neural connections to that information by retrieving it. Those additional retrieval leads us to make neural hooks, connecting certain information to other information. It is kind of like a muscle having to move and work in order to build up strength.

So how does the act of recalling can be polished into a better tool for learning?

The answer can be simple: memory flash cards!

If you don't have any paper on hand or just don't want to carry them as an additional burden, there are computer programs that help you create digital flash cards that you can store on your computer machine. These programs often feature algorithms that manage these flash cards intelligently, mostly depending on your feedback. Examples include [Anki](https://apps.ankiweb.net/), [SuperMemo](https://www.supermemo.com/), and [Quizlet](https://quizlet.com/).

My main go-to flashcard program is Anki and I can say that it is pretty top-notch for your flashcard recalling needs. Its biggest features include the number of flashcard sets that are created by millions of users (although I recommend to make the flash cards yourself), the number of options you have, and the ability to effectively shuffle through the cards based on your feedback on the card. For example, cards that you rated as difficult will appear more often and will not stop until you got it right while the cards that you rated easier will appear less. You can also customize how early those cards will appear to suit with your recalling study.

Now with that out of the way, there are some things that you need to keep in mind when recalling:

- recalling is not a very effective way of learning as that will lead to full reliance on rote memorization which is not an effective way on its own
- recalling can also lead to the habit of recognizing concepts by relying on a set of keywords; recognition of such cues is not the same as actually understanding the concept
- recalling, when used inefficiently, is just parroting the source material and can lead to a shallow understanding of the concept

If you want to recall with the flash cards effectively, you can refer to [College Info Geek's article on using flash cards](https://collegeinfogeek.com/flash-card-study-tips/).

## Cornell note-taking system
Most of us (including myself) have taken lectures through the old-fashioned way: just copying everything the lecturer writes (or presents in their slides). Every sentences and example, even the format of the writings on the board, are just plain copied without a word and only with the thought of finishing your writing. This method, as you might tell, is quite an inefficient one. I think the only reason why we do this way is only because it is encouraged in most schools and there is even a system wherein the teacher checks the notes of their students as a part of their grade. 

Several practical methods are formulated just to reduce this kind of problem. One of them often including a *tl;dr* version of their lectures at the very end of their lectures (or slides). The other is quite simple, the class is encouraged not to copy at all and just send out a handout (or the lecture slides) to the class.

But there is one problem though, most of the solutions are done by the presenter. With these kinds of solution, the whole class, in turn, is not that involved, anymore. The whole lecture scene is just reduced to a handout/slide waiting game. Or worse, simply an endurance game, with attendance being the only reason as to why the class (or a part of the class 😉) ever shows up in the first place.

Fortunately, there are other ways for the students themselves to take notes quite efficiently. The skill of note-taking is quite important for the life in high school and beyond, not just when in classes. It can be the key for you to learn efficiently and independently. Taking notes in your own way is quite important as it will likely suit your learning style. If you want to start making notes in your own way, why not start with a template (HINT: it's in the header) and go on from there.

Enter: the Cornell note-taking system. It's a note-taking system advocated by an education professor, Walter Pauk, in his book, [How to Study at College](https://www.goodreads.com/book/show/15942191-how-to-study-in-college) and was named after the university that he's been teaching for. Aside from being a note-taking system, it also utilizes recalling and re-studying notes as their main way of learning, allowing students to understand ideas and concepts at a deeper level.

The very nice thing with this is you can do this note-taking system in any learning sessions. Whether you are in a class listening to your professor, reading a textbook, watching a video, or even documenting your experiments (yes, I've tried it). This note-taking system allows you to condense information into a tinier section, more than it should have for the most part. But that's not all, it also makes you recall, review, and reflect on your learnings.

Now, doing with this system is quite simple: you just need a paper and a pen. I recommend having more than one pen but less than three (colors) for a neater process and a more organized output. Although one pen is enough, you just have to be creative with how will you organize your notes with only one color of ink.

To get started, divide the paper into mainly 4 sections: the name of the subject, note-taking column, the cue column, and the summary.

Now, each of the section in the template represents something:

- name of the subject - obviously, it refers to the name of the subject
- the note-taking column - this is where your concise recordings are stored
- the cue column - this is where your main ideas and key points are written
- summary - contains the overview or the general idea of your learnings

Here's how to use the Cornell paper [based on the university that is named after it](http://lsc.cornell.edu/notes.html):

### Divide the Cornell note
First, divide the Cornell note paper into 4 sections. While there is no set rules or anything, most of the time, the Cornell notes are usually divided in this way: 

![Parts of a Cornell note]({{ 'assets/pictures/self-learning-series/personal-workflow/cornell-note-parts.png' | relative_url }})
<p class="caption">*Parts of a Cornell note*</p>

As you can see, the biggest section belongs to the note-taking column. While the cue column is on the other side of the note-taking column, as long as they are in the same line and leaving the cue column a moderate amount of space. The summary is at the bottom of the paper, leaving a considerate amount of space. With that said, obviously, the name of the subject has the smallest section.

### Note-taking session
After you divided the paper, record the lecture or your readings with a concise sentence. This is an important rule when taking with the Cornell note-taking system, don't be too elaborate or detailed with your recordings. This is especially obvious when you're in a live session such as in a lecture, a conference, or an online live lesson. 

The sky's the limit on how will structure your learnings but I do want to give some guideline for an effective note organization:

- **Use symbols to represent what you think is the main point and its subpoints** - you can use shapes or other graphical representations to represent that this point is quite important or a point that can be divided further; for example, I use circles to denote that it is one of the main ideas in the learning session; then I use squares to denote that this is an example of an idea/concept, triangles to denote a subpoint or supporting information, etc.
- **Use spacing effectively** - don't hesitate to use space to make your notes more readable and more organized; if you are very conscious to cram in as much information while using less space, you'll end up with a note that you yourself will be anxious to read (unless you can manage that, then more power to you ~~teach me pls~~)
- **Use indentation** - even though this is in the same point as the previous point but I think this is an important point on its own; this is another way of using spacing effectively; the primary example of that is when you use an outline - subpoints and other supporting information should start with it
- **Be brief and concise in your notes** - this has already been talked about but I'll say it again, in case you missed it; don't waste time taking every detail into things, just be concise with your points; this is especially important (and obvious) when you're in a live session

### Self-review
OK. Now, your class/conference/reading session is done, time to have some questions. **Write down questions and key points that explore the different aspects of the lesson in your notes.** This could be questions that explore the relationships between two noted ideas, clarify the meanings, extract key points, and overall, strengthen your memory. Rather than formulating and covering the questions in your head all alone which it can make your thoughts go pop out in a matter of seconds, writing down the questions yourself helps you to have the concepts stick more into your memory. This is quite an important move especially if you have an upcoming test right after.

**After that, cover the note-taking column (usually with another sheet of paper) then recite about the key points and answer the questions that you've written.** I know this is quite obvious but do not make up information just so that you can answer the question. If you weren't able to answer it, then leave it be for now.

Next, reflect on the material. **Usually, this is done by asking yourself some questions about the content of your notes and what you know.** Here are some of the common questions that you may use to effectively reflect on the lesson:

- What is the significance of these facts?
- What principles are they based on?
- What is the relationship between this lesson with the other lessons?
- How can I apply them?
- What is beyond this lesson?

**Then, review it including all of your previous notes.** Depending on the date of examination, you could spend it 10 minutes a week going back on your previous notes. Or spend 30 minutes, why not? Just don't cram 🙃.

**After all of that, write the summary.** The summary should be about the notes in that page. You don't need to add more, nothing much else.

## Pomodoro technique
This is probably something that you heard a lot of times with the productivity tips, articles, or advertisement plastered all over your GoogleAds space. It is a time management tool, helping you to focus on your task by using the rewarding system our brain subconsciously apply to ourselves. 

Pomodoro technique is a method developed by Francesco Cirillo while he was a university student 

We humans mostly reward ourselves each time we've done something: just being curious, doing a painstaking task, or anything, really. At the end of the task, we attain whether it is satisfaction or material (or both).

"Got our curiosity fulfilled? Quick! Let's do something that'll make us feel good", our brain says.

"Finally! Got that #$%%^@&! task done for 4 hours straight. Let's celebrate! 🎉", our brain says at another situation.

The pomodoro technique exploits that (in a good way, of course) by allowing you to be taken on a seat that encourages rewarding yourself. Basically, how this works is by working in short bursts, traditionally in 25 minutes. After each pomodoro, let yourself be rewarded (basically anything) for a short break, usually in 5 minutes. Every 4th pomodoro that has been done will reward you with a longer break, ranging from 15 to 30 minutes. Of course, the rules are not set in stone and you can configure the number of breaks and the length of time for each session for your specific use cases.

Of course, in order to utilize this technique, you need a timer. You can do it with your phone or the low-tech physical things which are said to be more effective since it is tangible and more real compared to the digitized versions. For me, I like to do this technique with a paper logging my pomodoro sessions and a timer app named [Forest](https://www.forestapp.cc/) since I don't have a physical timer (which serves a good opportunity for me to create a physical pomodoro timer 🙂).

It does not only go with the exploitation of the reward-based system our brain utilizes but it also helps us give a sense of accomplishment, depending on how you record raw data indicating your progress. If you keep and update a record, say a to-do list or a task tracker or a log of the pomodoro sessions you've taken, it helps you drive down further into passionately doing the action.

Apparently, the official named developer of the method has [his own website tackling the subject of the technique](https://francescocirillo.com/pages/pomodoro-technique) so I recommend you to take a gander there.

## Overlearning and deliberate practice
In starting out to learn, there is a practice that is being encouraged to do so: the act of practicing after mastery. **It's a simple and effective method of making our learnings to stay on our mind and make strong neural connections for that topic.** Unsurprisingly, there is a formal term for it: *overlearning*.

While overlearning is not inherently bad, it still has its places. Overlearning is quite a common practice for public speakers, teachers, and sports players trying to get the perfect hang of it. It also helps to create automaticity or a muscle memory and can be quite useful under times of nervousness and anxiety. Like all things, however, this practice should be moderated. 

If there is a repetition of overlearning, it may become a detriment and a waste of valuable learning time. The overpractice of overlearning is like solving every problem with one tool, even when that tool is not suitable for the job. Even if we managed to solve the problem with that tool that is clearly not suitable for the problem, it could lead us to fall under the illusion of competence and can make us feel that we're learning.

Instead of practicing overlearning from the get-go, we should move on to the next topic. **When we got the grasp of the concept or an idea, that's the signal that it's time to advance your learning into the more difficult topics to keep you at bay.** The previous topics can be practiced and that is the point of the moderate practice of overlearning. This kind of practice wherein we move up into learning more difficult topics is known as *deliberate practice*.

The practice of deliberate practice is indeed nice but there are some points that we have to make. This particular method at the end of the day is still a kind of practice. All practices have the tendency to instill some ideas into our minds. Overlearning can hammer down the points we have learned. Deliberately practicing can instill new perspectives, ideas, and concepts that we often need to learn and understand in order to become a more effective student of our chosen field. 

![Both methods in an example workflow]({{ 'assets/pictures/self-learning-series/personal-workflow/overlearning-and-deliberate-practice-workflow.png' | relative_url }})
<p class="caption">*Both methods in an example workflow*</p>

However, there are also moments that we practice without the prerequisite knowledge as some sort of a practice test. This could lead to a bad start of a learning session. There is this phenomenon called the *Einstellung effect* **wherein our pre-existing knowledge can impede our ability to learn about the new ideas**. 

We are often very focused and rigid when it comes to the knowledge that we are able to gather. This, unfortunately, has the huge disadvantage of not looking at other perspectives when solving problems. It prevents us from being innovative. 

A developer's example could be the use of trending tools. Most of the time, we associate learning the trending tools as a sort of a milestone in our career and most of the time, we are quite fixed with creating apps with those tools (almost) all of the time. Instead of using a smaller framework for our freelance project, we often use the trending framework that we just learned even though it could be an overkill. It prevents us from finding the optimal solution and what it could our program for the best.

In the world of sciences, this phenomena is quite present to everyone except for a few cases. There is a tendency that science advances from young people and people who are not originally trained in that field since they're immune to the effect. They often can see the relationship between concepts and they're disillusioned from the widely-agreed ideas and concepts that the field has come up to.

This adds the notion that the learning process is not simply learning concepts on top of each other (even though that is the case for most of the time). It is the process of unlearning old ideas in order to fit the new ideas that we try to understand. With this, it could lead to effective use of our pre-existing knowledge and can be flexible in our learning process.

## Testing
One of the most effective ways to learn, in my experience. As you can see right from the header, this is basically testing your knowledge. Of course, how you would test yourself depends on your choices: the type of application (whether it is with practice sets or with real-life problems) and the type of practice (whether it is casual, foundational, or deliberate). 

With this method, you are also forcing yourself to recall information, that is if you're willing to not look after the solution. It also stretches your understanding to the limit. It might make you feel intimidated and challenged but that is also another benefit in on itself. Over time, if you practice this method consistently, you are becoming "comfortable" in being uncomfortable. You might even like the feeling of being challenged! 

I admit that this is something I also struggle with even today. I sometimes tend to not test myself because it is making me feel quite uncomfortable. However, at times that I did go through this feeling is the reward of great satisfaction. That particular feeling is what got me back into challenging myself. As they say, who doesn't love a good challenge? So I say, try your best to push that limit, at least once per two days then aim for the higher level, once per day and a half, then once per day and a quarter, then once per... OK, you get it.

Now with all of this saying to test yourself into understanding this concept, the million-dollar question that you might ask is how do you test yourself. The key is choosing what type of practice you want to practice while gauging your level of understanding. 

- If you think that you need a refresher, just go casually but not too casual. 
- If you're unfamiliar with the subject, make sure that it is challenging enough but not to the point that frustrates you so much that you don't want to continue anymore. 
- If you're going to practice that pushes you to the limit, you might want to apply the same level of difficulty as the previous one.

All in all, testing yourself is quite a precious technique that validates and cements our understanding to a concept. I can say that it is completely impossible to not practice this technique if you want to level up your skills. Besides, how else are you going for the practical application if you're not even testing yourself?

## Communities and study groups
Self-learning is good and all but there are times where we cannot really understand a concept, solve a problem, or being competitive and motivated for too long. Besides, most of the learning that we've done in ourselves often came from others' discoveries, instructions, and observation. There are things that we cannot make a task done alone. That's where a community's significance shines in. 

As obvious as it can be, a community is a group of people of similar interests and different skill levels connected in a platform. The communities that you're interacting with can help you in a lot of ways. There are times where you can help others, too. They can give you the knowledge and the competition to drive your motivation into doing better and hone your skills. Being in a community is a give-and-take type of situation where your appropriate feedback matters. 

There are a lot of ways to connect with a community but you have to consider what type of community you'll be interacting with. Whether it is an online-exclusive group or a local group, try to be active within those communities and you'll be reaping out the benefits from being in one. Who knows, maybe you can also come across the opportunity to join in with a study group.

A study group is basically a small community of students trying to learn or hone their skills together. Being in one is a really good experience and can help you in a very beneficial way. Joining one isn't really that difficult: you can join someone has already established or initiate one yourself (OK, this one is more difficult). You can join an online group or within a local setting like in a school wherein it's even more beneficial (at least in my experience).

Within a study group most likely means that you're at the same level as your other members of the group. It is quite great to keep yourself accountable between your members and checking each other out how well they do. 

I also heard of another type of group called the *mastermind groups* (or as Thomas Frank from College Info Geek would call it, [Jedi councils](https://collegeinfogeek.com/jedi-councils/)) wherein they mostly keep you accountable within your fellow masterminds and can consist of people in different professions. Being in one is also quite beneficial as you can gain knowledge and perspectives far from what you usually see in your chosen discipline.

Just to keep these points in mind when joining in a study or mastermind group:

- **Make sure to have a roadmap** - of course, if you're going with a group of students learning within the same discipline, you need to have a map to keep your members and yourself consistent with your studies
-  **Have an accountability meeting** - this can be a simple "How do you do this week?" online discussion to a local meet-up; anything that keeps your fellow members (and you) in check

## Two notes system
This is a learning technique that I discovered by utilizing two notebooks. You can go with any kinds of notebooks but for this, I prefer my set-up: one onsite notebook and one digital notebook. 

Basically, you just take note (with any notetaking techniques you prefer) on the first notebook then a few weeks or sessions later, you would take note of that again in the other notebook. Simple as that.

Think of the process as a simple publication of a book. You are the author of the book, you wrote the book yourself and finished the first edition of your book.

Recreating your notes into a more digestible reference is basically like making a second edition of your book. You are revising your book with an errata as your reference, clearing things up and making the concept to be more understandable. 

In real-life case, you're editing your notes to be more understandable the next time you review. Rewriting the notes (or writing from scratch with your understanding) makes your brain to understand more of the concept since you do the action yourself, you explain the concept that you yourself would understand. Add that with the goal of making your notes to explain as if you're talking with someone who's unfamiliar with the subject and it will be a process of note-taking taken to a higher level.

You can make up other options that are suited in your learning style. In my case, I first take note with the Cornell note system on my onsite notebook. Then a few weeks later, I take note of that particular concept again albeit with a few differences. This time, I went taking notes similar to how I would write my *Simplified!* posts, using the Feynman technique. This keeps me refreshing and cementing further the concepts into my mind.

Remember the [remote repository that contains notes on stuff I didn't know](https://github.com/foo-dogsquared/a-remote-repo-full-of-notes-of-things-i-do-not-know-about)? Yes, that's where my second version of notes are kept. After I learn about a concept or a subject matter and a few weeks or sessions have passed, I will take a look on my paper notebook, remember as much as I can, and start writing on my text editor as if I'm explaining it to my colleagues.

![The two notes system workflow]({{ 'assets/pictures/self-learning-series/personal-workflow/two-notes-system-workflow.png' | relative_url }})
<p class="caption">*The two notes system workflow*</p>

Basically, this so-called "two notes system" that I created is just a review note or making a second version of the notes.

## Conclusion
Different techniques give different results but that doesn't necessarily mean that we should be all locked up in one routine. Surely, we can combine all of them in a way that we are most comfortable with. There is a lot of possibility of combining these techniques (and your own techniques) in a way that could lead to a better or worse learning process.

Modifying some changes on our already established habits can also help us learn especially with sleeping routines. Trying to sleep (and wake) earlier help a lot, if it doesn't conflict with your schedule, of course. Plus, waking up on 4 AM is a great feeling (on my area, at least) with the chill winds and the heat is void as you watch the sun just taking a peek on the sky. 

If we make a more positive version of the changes in our habits, maybe it'll change your mind into things.

What are your personal techniques that you use for learning? Tell it in the comments. It's called interactivity and I love feedback for this post. 😁 

## (Re)Sources:
- ### Audio
    - [5 Learning Anti-Patterns from *Developer Tea*](https://developertea.simplecast.fm/aeb7c2cf)
    - [Jedi Councils from *College Info Geek Podcast*](https://collegeinfogeek.com/jedi-councils/)
- ### Books (or book, there's only one of them)
    - [Mindset (*C. Dweck*)](https://www.goodreads.com/book/show/40745.Mindset) 
- ### Courses
    - [Learning How to Learn from *McMaster University & University of California San Diego (Coursera)*](https://www.coursera.org/learn/learning-how-to-learn/)
    - [Learning How to Learn for Youth from *Arizona State University (Coursera)*](https://www.coursera.org/learn/learning-how-to-learn-youth)
- ### Videos
    - [How to Learn Faster With the Feynman Technique from *Thomas Frank*](https://youtu.be/f-qkGJBPts)
    - [Learn Faster With The Feynman Technique from *Scott Young*](https://youtu.be/FrNqSLPaZLc)
    - [The Most Powerful Mindset for Success from *Freedom in Thought*](https://www.youtube.com/watch?v=qjBdcyueom8)
    - [The Most Powerful Way to Remember What You Study from *Thomas Frank*](https://www.youtube.com/watch?v=eVajQPuRmk8)
- ### Web
    - [8 Better Ways to Make and Study Flash Cards from *College Info Geek*](https://collegeinfogeek.com/flash-card-study-tips/)
    - [Book Summary: “A Mind For Numbers”, Barbara Oakley from *Faster to Master*](https://fastertomaster.com/a-mind-for-numbers-barbara-oakley/)
    - [Cornell Notes from *The Learning Toolbox Home*](http://coe.jmu.edu/LearningToolbox/cornellnotes.html)
    - [Fixed vs. Growth: The Two Basic Mindsets That Shape Our Lives from *Brain Pickings*](https://www.brainpickings.org/2014/01/29/carol-dweck-mindset/)
    - [How To Learn More Outside Of Class Than You Ever Could Inside It from *College Info Geek*](https://collegeinfogeek.com/self-study/)
    - [Learning How to Learn Class Notes by *Erik Cianci*](https://erikcianci.com/blog/learning-how-to-learn)
    - [Mindset on *Wikipedia*](https://en.wikipedia.org/wiki/Mindset)
    - [Pomodoro Technique from *Francesco Cirillo*](https://francescocirillo.com/pages/pomodoro-technique)
    - [Richards Feynman's Notebook Technique from *OpenCulture*](http://www.openculture.com/2017/04/richard-feynmans-notebook-technique-will-help-you-learn-any-subject.html)
    - [Spaced repetition from *College Info Geek*](https://collegeinfogeek.com/spaced-repetition-memory-technique/)
    - [The Cornell Note-taking System from *Cornell University*](http://lsc.cornell.edu/notes.html)
    - [The Feynman Notebook Method by *Cal Newport*](http://calnewport.com/blog/2015/11/25/the-feynman-notebook-method/)

-----

**P.S.: *Yeah, I'm a fan of College Info Geek when it comes to self-study tips, they're a valuable resource.***

**P.P.S.: *I created a [visual flowchart of my study workflow]({{ 'assets/pictures/self-learning-series/personal-workflow/personal-learning-workflow-white-bg.png' | relative_url }}) since I'm just testing my visual aid creation skills at the time so why not share it. Also, I do want to solidify the workflow into my noggin, so there's that.***
